Index: trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgExU64.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgExU64.asm	(revision 25665)
+++ trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgExU64.asm	(revision 25665)
@@ -0,0 +1,88 @@
+; $Id$
+;; @file
+; IPRT - ASMAtomicCmpXchgExU64().
+;
+
+;
+; Copyright (C) 2006-2010 Sun Microsystems, Inc.
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%include "iprt/asmdefs.mac"
+
+BEGINCODE
+
+;;
+; Atomically Exchange an unsigned 64-bit value, ordered.
+;
+; @param    pu64     x86:ebp+8   gcc:rdi  msc:rcx
+; @param    u64New   x86:ebp+c   gcc:rsi  msc:rdx
+; @param    u64Old   x86:ebp+14  gcc:rcx  msc:r8
+; @param    u64Old   x86:ebp+1c  gcc:rdx  msc:r9
+;
+; @returns  bool result: true if succesfully exchanged, false if not.
+;           x86:al
+;
+BEGINPROC_EXPORTED ASMAtomicCmpXchgExU64
+%ifdef RT_ARCH_AMD64
+ %ifdef ASM_CALL64_MSC
+        mov     rax, r8
+        lock cmpxchg [rcx], rdx
+        mov     [r9], rax
+ %else
+        mov     rax, rcx
+        lock cmpxchg [rdi], rsi
+        mov     [rdx], rax
+ %endif
+        setz    al
+        movzx   eax, al
+        ret
+%endif
+%ifdef RT_ARCH_X86
+        push    ebp
+        mov     ebp, esp
+        push    ebx
+        push    edi
+
+        mov     ebx, dword [ebp+0ch]
+        mov     ecx, dword [ebp+0ch + 4]
+        mov     edi, [ebp+08h]
+        mov     eax, dword [ebp+14h]
+        mov     edx, dword [ebp+14h + 4]
+        lock cmpxchg8b [edi]
+        mov     edi, [ebp + 1ch]
+        mov     [edi],     eax
+        mov     [edi + 4], edx
+        setz    al
+        movzx   eax, al
+
+        pop     edi
+        pop     ebx
+        leave
+        ret
+%endif
+ENDPROC ASMAtomicCmpXchgExU64
+
Index: trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgU64.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgU64.asm	(revision 25664)
+++ trunk/src/VBox/Runtime/common/asm/ASMAtomicCmpXchgU64.asm	(revision 25665)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2009 Sun Microsystems, Inc.
+; Copyright (C) 2006-2010 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/asm/ASMAtomicUoReadU64.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMAtomicUoReadU64.asm	(revision 25665)
+++ trunk/src/VBox/Runtime/common/asm/ASMAtomicUoReadU64.asm	(revision 25665)
@@ -0,0 +1,74 @@
+; $Id$
+;; @file
+; IPRT - ASMAtomicUoReadU64().
+;
+
+;
+; Copyright (C) 2006-2010 Sun Microsystems, Inc.
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%include "iprt/asmdefs.mac"
+
+BEGINCODE
+
+;;
+; Atomically reads 64-bit value.
+;
+; @param   pu64     x86:ebp+8
+;
+; @returns The current value. (x86:eax+edx)
+;
+;
+BEGINPROC_EXPORTED ASMAtomicUoReadU64
+%ifdef RT_ARCH_AMD64
+ %ifdef ASM_CALL64_MSC
+        mov     rax, [rcx]
+ %else
+        mov     rax, [rdi]
+ %endif
+        ret
+%endif
+%ifdef RT_ARCH_X86
+        push    ebp
+        mov     ebp, esp
+        push    ebx
+        push    edi
+
+        xor     eax, eax
+        xor     edx, edx
+        mov     edi, [ebp+08h]
+        xor     ecx, ecx
+        xor     ebx, ebx
+        cmpxchg8b [edi]
+
+        pop     edi
+        pop     ebx
+        leave
+        ret
+%endif
+ENDPROC ASMAtomicUoReadU64
+
Index: trunk/src/VBox/Runtime/common/asm/ASMAtomicXchgU64.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMAtomicXchgU64.asm	(revision 25665)
+++ trunk/src/VBox/Runtime/common/asm/ASMAtomicXchgU64.asm	(revision 25665)
@@ -0,0 +1,80 @@
+; $Id$
+;; @file
+; IPRT - ASMAtomicXchgU64().
+;
+
+;
+; Copyright (C) 2006-2010 Sun Microsystems, Inc.
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%include "iprt/asmdefs.mac"
+
+BEGINCODE
+
+;;
+; Atomically Exchange an unsigned 64-bit value, ordered.
+;
+; @param    pu64     x86:ebp+8   gcc:rdi  msc:rcx
+; @param    u64New   x86:ebp+c   gcc:rsi  msc:rdx
+;
+; @returns  bool result: true if succesfully exchanged, false if not.
+;           x86:al
+;
+BEGINPROC_EXPORTED ASMAtomicXchgU64
+%ifdef RT_ARCH_AMD64
+ %ifdef ASM_CALL64_MSC
+        mov     rax, r8
+.try_again:
+        lock cmpxchg [rcx], rdx
+ %else
+.try_again:
+        mov     rax, rcx
+        lock cmpxchg [rdi], rsi
+ %endif
+        jnz     .try_again
+        ret
+%endif
+%ifdef RT_ARCH_X86
+        push    ebp
+        mov     ebp, esp
+        push    ebx
+        push    edi
+
+.try_again:
+        mov     ebx, dword [ebp+0ch]
+        mov     ecx, dword [ebp+0ch + 4]
+        mov     edi, [ebp+08h]
+        lock cmpxchg8b [edi]
+        jnz     .try_again
+
+        pop     edi
+        pop     ebx
+        leave
+        ret
+%endif
+ENDPROC ASMAtomicXchgU64
+